//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 名前付きオブジェクトデータベースヘッダ
 * @author Junpee
 */

#ifndef NAMED_OBJECT_DATABASE_H_
#define NAMED_OBJECT_DATABASE_H_

#include <Core/Container/HashMap.h>
#include <Core/Container/Deque.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * 名前付きオブジェクトデータベース
 */
template <typename Type>
class NamedObjectDatabase{
public:
	/**
	 * コンストラクタ
	 * @param capacity 初期容量
	 * @param loadFactor 負荷係数
	 */
	NamedObjectDatabase(int capacity = 256, float loadFactor = 0.75f) :
		hash_(capacity, loadFactor), array_(capacity){
	}

	/**
	 * デストラクタ
	 */
	virtual ~NamedObjectDatabase(){
		Assert(hash_.getCount() == 0);
		Assert(array_.getCount() == 0);
	}

	//--------------------------------------------------------------------------
	// オブジェクトの追加と削除
	//--------------------------------------------------------------------------
	/**
	 * オブジェクトの追加
	 * @param object 追加するオブジェクト
	 * @return 成功すればtrue
	 */
	virtual bool add(const String& name, Type* object){
		Assert(name.getSize() != 0);
		Assert(object != NULL);
		if(search(name) != NULL){ return false; }
		hash_.put(name, object);
		array_.pushBack(object);
		return true;
	}

	/**
	 * オブジェクトの削除
	 * @param object 削除するオブジェクト
	 * @return 成功すればtrue
	 */
	virtual bool remove(const String& name, Type* object){
		Assert(name.getSize() != 0);
		Assert(object != NULL);
		Type* removeObject = search(name);
		if(removeObject == NULL){ return false; }
		if(removeObject != object){ return false; }
		if(array_.removeByValue(object) == -1){ return false; }
		if(hash_.remove(name) == NULL){ Assert(false); }
		return true;
	}

	/**
	 * クリア
	 * @return 削除したオブジェクト数
	 */
	virtual int clear(){
		int result = getCount();
		array_.clear();
		hash_.clear();
		return result;
	}

	//--------------------------------------------------------------------------
	// オブジェクトへのアクセス
	//--------------------------------------------------------------------------
	/**
	 * オブジェクト数の取得
	 * @return オブジェクト数
	 */
	virtual int getCount(){ return array_.getCount(); }

	/**
	 * オブジェクトの取得
	 * @param index オブジェクトのインデクス
	 * @return オブジェクト
	 */
	virtual Type* get(int index){ return array_.get(index); }

	/**
	 * オブジェクトの検索
	 * @param name 検索するオブジェクト名
	 * @return オブジェクト
	 */
	virtual Type* search(const String& name){ return hash_.get(name); }

private:
	//--------------------------------------------------------------------------
	// コピーコンストラクタの隠蔽
	NamedObjectDatabase(const NamedObjectDatabase& copy);

	// 代入コピーの隠蔽
	void operator =(const NamedObjectDatabase& copy);

	// ハッシュ
	HashMap<String, Type*> hash_;
	// 配列
	Deque<Type*> array_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of NAMED_OBJECT_DATABASE_H_
//------------------------------------------------------------------------------
